/**
 * Created by zy8 on 2017/2/28.
 */
const Client = require('ftp');
var fs = require('fs');
let _options;
module.exports = {
    /**
     * init client
     * @param options
     * @returns {*}
     */

    setOptions(options) {
        _options = options;
    },

    /**
     * upload
     * @returns {*}
     */ //
    upload(localPath, remotePath){
        return new Promise(function (resolve, reject) {
            client = getClient();
            client.on('ready', function () {
                client.put(localPath, remotePath, function (err) {
                    if (err) {
                        return reject(err);
                    }
                    client.end();
                    resolve();
                });
            });
            client.connect(_options);
        });
    },

    /**
     * download
     * @returns {*}
     */ //'foo.local-copy.txt'
    download(localPath, remotePath){
        //set ready 事件
        return new Promise(function (resolve, reject) {
            client = getClient();
            client.on('ready', function () {
                client.get(remotePath, function (err, stream) {
                    if (err) {
                        return reject(err);
                    }
                    stream.once('close', function () {
                        client.end();
                    });
                    stream.pipe(fs.createWriteStream(localPath));
                });
            });
            client.connect(_options);
            resolve();
        });
    },


    pwd(){
        return new Promise(function (resolve, reject) {
            client = getClient();
            client.on('ready', function () {
                client.pwd(function (err, cwd) {
                    if (err) {
                        return reject(err)
                    }
                    console.log(cwd);
                    client.end();
                    resolve(cwd);
                });
            });
            client.connect(_options);
        });
    },

    list(remotePath){
        return new Promise(function (resolve, reject) {
            client = getClient();
            client.on('ready', function () {
                client.list(remotePath, function (err, list) {
                    if (err) {
                        return reject(err)
                    }
                    console.log(list);
                    client.end();
                    resolve(list);
                });
            });
            client.connect(_options);
        });
    },

};

var getClient = function(){
    const client = new Client();
    client.on('greeting', function (msg) {
        console.log('msg is ' + msg);
    });
    client.on('error', function (err) {
        console.log('err is ' + err);
    });
    return client;
};